Summary:        High-performance, full-featured text search engine
Name:           lucene
Version:        5.5.0
%define subrel  1
Release:        %mkrel 4
Epoch:          0
License:        ASL 2.0
Group:          Development/Java
URL:            http://lucene.apache.org/
# solr source contains both lucene and dev-tools
Source0:        http://www.apache.org/dist/lucene/solr/%{version}/solr-%{version}-src.tgz

Patch0:         0001-Disable-ivy-settings.patch
Patch1:         0002-Dependency-generation.patch
Patch2:         0001-SOLR-11477-Disallow-resolving-of-external-entities-i.patch

BuildRequires:  ant
BuildRequires:  ivy-local
BuildRequires:  maven-local
BuildRequires:  mvn(com.carrotsearch.randomizedtesting:randomizedtesting-runner)
BuildRequires:  mvn(com.ibm.icu:icu4j)
BuildRequires:  mvn(commons-codec:commons-codec)
BuildRequires:  mvn(commons-logging:commons-logging)
BuildRequires:  mvn(com.spatial4j:spatial4j)
BuildRequires:  mvn(jakarta-regexp:jakarta-regexp)
BuildRequires:  mvn(javax.servlet:javax.servlet-api)
BuildRequires:  mvn(javax.servlet:servlet-api)
BuildRequires:  mvn(junit:junit)
BuildRequires:  mvn(net.sourceforge.nekohtml:nekohtml)
BuildRequires:  mvn(org.antlr:antlr4-runtime)
BuildRequires:  mvn(org.apache:apache:pom:)
BuildRequires:  mvn(org.apache.commons:commons-compress)
BuildRequires:  mvn(org.apache.felix:maven-bundle-plugin)
BuildRequires:  mvn(org.apache.httpcomponents:httpclient)
BuildRequires:  mvn(org.apache.httpcomponents:httpcore)
BuildRequires:  mvn(org.apache.uima:Tagger)
BuildRequires:  mvn(org.apache.uima:uimaj-core)
BuildRequires:  mvn(org.apache.uima:WhitespaceTokenizer)
BuildRequires:  mvn(org.carrot2:morfologik-fsa)
BuildRequires:  mvn(org.carrot2:morfologik-polish)
BuildRequires:  mvn(org.carrot2:morfologik-stemming)
BuildRequires:  mvn(org.codehaus.mojo:buildnumber-maven-plugin)
BuildRequires:  mvn(org.eclipse.jetty:jetty-continuation)
BuildRequires:  mvn(org.eclipse.jetty:jetty-http)
BuildRequires:  mvn(org.eclipse.jetty:jetty-io)
BuildRequires:  mvn(org.eclipse.jetty:jetty-server)
BuildRequires:  mvn(org.eclipse.jetty:jetty-servlet)
BuildRequires:  mvn(org.eclipse.jetty:jetty-util)
BuildRequires:  mvn(org.ow2.asm:asm)
BuildRequires:  mvn(org.ow2.asm:asm-commons)
BuildRequires:  mvn(xerces:xercesImpl)

Provides:       %{name}-core = %{epoch}:%{version}-%{release}

BuildArch:      noarch

%description
Apache Lucene is a high-performance, full-featured text search
engine library written entirely in Java. It is a technology suitable
for nearly any application that requires full-text search, especially
cross-platform.

%package parent
Summary:      Parent POM for Lucene

%description parent
Parent POM for Lucene.

%package solr-grandparent
Summary:      Lucene Solr grandparent POM

%description solr-grandparent
Lucene Solr grandparent POM.

%package backward-codecs
Summary:      Lucene Backward Codecs Module

%description backward-codecs
Codecs for older versions of Lucene.

%package benchmark
Summary:      Lucene Benchmarking Module

%description benchmark
Lucene Benchmarking Module.

%package replicator
Summary:      Lucene Replicator Module

%description replicator
Lucene Replicator Module.

%package grouping
Summary:      Lucene Grouping Module

%description grouping
Lucene Grouping Module.

%package highlighter
Summary:      Lucene Highlighter Module

%description highlighter
Lucene Highlighter Module.

%package misc
Summary:      Miscellaneous Lucene extensions

%description misc
Miscellaneous Lucene extensions.

%package test-framework
Summary:      Apache Lucene Java Test Framework

%description test-framework
Apache Lucene Java Test Framework.

%package memory
Summary:      Lucene Memory Module

%description memory
High-performance single-document index to compare against Query.

%package expressions
Summary:      Lucene Expressions Module

%description expressions
Dynamically computed values to sort/facet/search on based on a pluggable
grammar.

%package demo
Summary:      Lucene Demo Module

%description demo
Demo for Apache Lucene Java.

%package classification
Summary:      Lucene Classification Module

%description classification
Lucene Classification Module.

%package join
Summary:      Lucene Join Module

%description join
Lucene Join Module.

%package suggest
Summary:      Lucene Suggest Module

%description suggest
Lucene Suggest Module.

%package facet
Summary:      Lucene Facets Module

%description facet
Package for Faceted Indexing and Search.

%package analysis
Summary:      Lucene Common Analyzers

%description analysis
Lucene Common Analyzers.

%package sandbox
Summary:      Lucene Sandbox Module

%description sandbox
Lucene Sandbox Module.

%package queries
Summary:      Lucene Queries Module

%description queries
Lucene Queries Module.

%package spatial
Summary:      Spatial Strategies for Apache Lucene

%description spatial
Spatial Strategies for Apache Lucene.

%package spatial3d
Summary:      Lucene Spatial 3D

%description spatial3d
Spatial shapes implemented using 3D planar geometry

%package codecs
Summary:      Codecs and postings formats for Apache Lucene

%description codecs
Codecs and postings formats for Apache Lucene.

%package queryparser
Summary:      Lucene QueryParsers Module

%description queryparser
Lucene QueryParsers Module.

%package analyzers-smartcn
Summary:      Smart Chinese Analyzer

%description analyzers-smartcn
Lucene Smart Chinese Analyzer.

%package analyzers-phonetic
Summary:      Lucene Phonetic Filters

%description analyzers-phonetic
Provides phonetic encoding via Commons Codec.

%package analyzers-icu
Summary:      Lucene ICU Analysis Components

%description analyzers-icu
Provides integration with ICU (International Components for Unicode) for
stronger Unicode and internationalization support.

%package analyzers-morfologik
Summary:      Lucene Morfologik Polish Lemmatizer

%description analyzers-morfologik
A dictionary-driven lemmatizer for Polish (includes morphosyntactic
annotations).

%package analyzers-uima
Summary:      Lucene UIMA Analysis Components

%description analyzers-uima
Lucene Integration with UIMA for extracting metadata from arbitrary (text)
fields and enrich document with features extracted from UIMA types (language,
sentences, concepts, named entities, etc.).

%package analyzers-kuromoji
Summary:      Lucene Kuromoji Japanese Morphological Analyzer

%description analyzers-kuromoji
Lucene Kuromoji Japanese Morphological Analyzer.

%package analyzers-stempel
Summary:      Lucene Stempel Analyzer

%description analyzers-stempel
Lucene Stempel Analyzer.


%package javadoc
Summary:        Javadoc for Lucene

%description javadoc
%{summary}.

%prep
%setup -q -n solr-%{version}

%patch0 -p1
%patch1 -p1
%patch2 -p1

rm -rf solr

find -name "*.jar" -delete

mv lucene/*.txt .

sed -i -e "s|/Export-Package>|/Export-Package><_nouses>true</_nouses>|g" dev-tools/maven/pom.xml.template

# unresolvable test dep
%pom_remove_dep com.spatial4j:spatial4j::test lucene/spatial

# suggest provides spellchecker
%mvn_alias :%{name}-suggest :%{name}-spellchecker

# compatibility with existing packages
%mvn_alias :%{name}-analyzers-common :%{name}-analyzers

%mvn_package ":%{name}-analysis-modules-aggregator" %{name}-analysis
%mvn_package ":%{name}-analyzers-common" %{name}-analysis
%mvn_package ":{*}-aggregator" @1

%build
pushd %{name}
# generate dependencies
ant generate-maven-artifacts -Divy.mode=local -Dversion=%{version}

# fix source dir + move to expected place
for pom in `find build/poms/%{name} -name pom.xml`; do
    sed 's/\${module-path}/${basedir}/g' "$pom" > "${pom##build/poms/%{name}/}"
done
%pom_remove_plugin :forbiddenapis
for module in test-framework; do
    %pom_remove_plugin :forbiddenapis ${module}
done

%pom_disable_module src/test core
%pom_disable_module src/test codecs

# test deps
%pom_add_dep org.ow2.asm:asm::test demo
%pom_add_dep org.ow2.asm:asm-commons::test demo
%pom_add_dep org.antlr:antlr-runtime::test demo

popd

mv lucene/build/poms/pom.xml .

%pom_disable_module solr
%pom_remove_plugin :gmaven-plugin
%pom_remove_plugin :forbiddenapis
%pom_remove_plugin :maven-enforcer-plugin

# For some reason TestHtmlParser.testTurkish fails when building inside SCLs
%mvn_build -s -f

# Fix OSGi metadata in misc module
pushd lucene/misc/target
unzip lucene-misc-%{version}.jar META-INF/MANIFEST.MF
sed -i -e '1aRequire-Bundle: org.apache.lucene.core\r' META-INF/MANIFEST.MF
jar ufm lucene-misc-%{version}.jar META-INF/MANIFEST.MF 2>&1 > /dev/null
popd

# analyzers-common needs versioned requires on package from core
# maven-bundle-plugin doesn't seem to recognize this case on F24
#%%if 0%%{?fedora} == 24
pushd lucene/analysis/common/target
unzip lucene-analyzers-common-%{version}.jar META-INF/MANIFEST.MF
sed -i -e 's/org.apache.lucene.analysis,/org.apache.lucene.analysis;version="[5.5,6)",/' META-INF/MANIFEST.MF
jar ufm lucene-analyzers-common-%{version}.jar META-INF/MANIFEST.MF 2>&1 > /dev/null
popd
#%%endif

%install
%mvn_install

# Use the same directory of the main package for subpackage licence and docs
%global _docdir_fmt %{name}

%files -f .mfiles-%{name}-core
%doc CHANGES.txt README.txt MIGRATE.txt
%license LICENSE.txt NOTICE.txt

%files parent -f .mfiles-%{name}-parent
%files solr-grandparent -f .mfiles-%{name}-solr-grandparent
%files benchmark -f .mfiles-%{name}-benchmark
%files backward-codecs -f .mfiles-%{name}-backward-codecs
%files replicator -f .mfiles-%{name}-replicator
%files grouping -f .mfiles-%{name}-grouping
%files highlighter -f .mfiles-%{name}-highlighter
%files misc -f .mfiles-%{name}-misc
%files test-framework -f .mfiles-%{name}-test-framework
%files memory -f .mfiles-%{name}-memory
%files expressions -f .mfiles-%{name}-expressions
%files demo -f .mfiles-%{name}-demo
%files classification -f .mfiles-%{name}-classification
%files join -f .mfiles-%{name}-join
%files suggest -f .mfiles-%{name}-suggest
%files facet -f .mfiles-%{name}-facet
%files analysis -f .mfiles-%{name}-analysis
%files sandbox -f .mfiles-%{name}-sandbox
%files queries -f .mfiles-%{name}-queries
%files spatial -f .mfiles-%{name}-spatial
%files spatial3d -f .mfiles-%{name}-spatial3d
%files codecs -f .mfiles-%{name}-codecs
%files queryparser -f .mfiles-%{name}-queryparser
%files analyzers-smartcn -f .mfiles-%{name}-analyzers-smartcn
%files analyzers-phonetic -f .mfiles-%{name}-analyzers-phonetic
%files analyzers-icu -f .mfiles-%{name}-analyzers-icu
%files analyzers-morfologik -f .mfiles-%{name}-analyzers-morfologik
%files analyzers-uima -f .mfiles-%{name}-analyzers-uima
%files analyzers-kuromoji -f .mfiles-%{name}-analyzers-kuromoji
%files analyzers-stempel -f .mfiles-%{name}-analyzers-stempel

%files javadoc -f .mfiles-javadoc
%license LICENSE.txt NOTICE.txt



%changelog
* Sat Nov 04 2017 daviddavid <daviddavid> 0:5.5.0-4.1.mga6
+ Revision: 1175772
- add patch to fix CVE-2017-12629 (mga#21976)

* Mon Jul 18 2016 daviddavid <daviddavid> 0:5.5.0-4.mga6
+ Revision: 1042444
- analyzers-common should have versioned requires on package from core

* Fri Jul 08 2016 daviddavid <daviddavid> 0:5.5.0-3.mga6
+ Revision: 1039808
- Misc module should require core module, the split package
  causes problems for OSGi consumers
- Add missing BR on ant, fixes FTBFS

* Sat May 14 2016 shlomif <shlomif> 0:5.5.0-2.mga6
+ Revision: 1015289
- Rebuild for the new UCI (new major)

* Wed Mar 02 2016 neoclust <neoclust> 0:5.5.0-1.mga6
+ Revision: 983250
- New version 5.5.0
- Second rebuild of the java stack

* Tue Feb 23 2016 neoclust <neoclust> 0:5.4.1-3.mga6
+ Revision: 977241
- First rebuild of the java stack
- sync package lucene with fedora

  + umeabot <umeabot>
    - Mageia 6 Mass Rebuild

* Fri Dec 26 2014 pterjan <pterjan> 0:4.10.2-1.mga5
+ Revision: 806066
- Add missing BuildRequires
- Sync with Fedora 21 (Update to 4.0.2)

* Wed Oct 15 2014 umeabot <umeabot> 0:3.6.2-6.mga5
+ Revision: 739425
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 0:3.6.2-5.mga5
+ Revision: 682040
- Mageia 5 Mass Rebuild

* Sun Jun 15 2014 dmorgan <dmorgan> 0:3.6.2-4.mga5
+ Revision: 636500
- Remove unneeded BR jline. Resolves RHBZ#1023015.

* Tue Dec 31 2013 dmorgan <dmorgan> 0:3.6.2-3.mga4
+ Revision: 563443
- Rebuild against new javapackages
- Update to upstream 3.6.2 release.
- Upload new tarball for dev-tools as checksum could not be
  reproduced with given commands listed in comment.

  + umeabot <umeabot>
    - Mageia 4 Mass Rebuild

* Mon Jul 08 2013 dmorgan <dmorgan> 0:3.6.0-9.mga4
+ Revision: 451310
- Always install grand-parent pom as well.

* Mon Jul 08 2013 dmorgan <dmorgan> 0:3.6.0-8.mga4
+ Revision: 451307
- Always install lucene-parent pom.

* Mon Jul 08 2013 dmorgan <dmorgan> 0:3.6.0-3.mga4
+ Revision: 451183
- Fix OSGi medatada. In particular:
- Missing import javax.management (lucene-core)
- Missing import javax.xml.parsers and org.xml.sax.helpers
 (lucene-analysis)
- BundleVersion updated to 3.6.0 (lucene-core & lucene-analysis)

* Sat Jan 12 2013 umeabot <umeabot> 0:3.6.0-2.mga3
+ Revision: 359076
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Wed Sep 12 2012 dmorgan <dmorgan> 0:3.6.0-1.mga3
+ Revision: 292710
- New version

* Thu Jul 05 2012 dmorgan <dmorgan> 0:2.9.4-8.mga3
+ Revision: 268334
- Rebuild to generate osgi() provides

* Fri Dec 23 2011 dmorgan <dmorgan> 0:2.9.4-2.mga2
+ Revision: 186291
- Fix duplicate Manifes-version warnings. ( From Fedora)

* Tue Jul 19 2011 dmorgan <dmorgan> 0:2.9.4-1.mga2
+ Revision: 126678
- New version 2.9.4

* Sun Jan 23 2011 dmorgan <dmorgan> 0:2.4.1-0.0.1.mga1
+ Revision: 34494
- New version 2.4.1
  Add fedora patches
- imported package lucene


* Fri Dec 03 2010 Oden Eriksson <oeriksson@mandriva.com> 0:2.4.0-0.0.3mdv2011.0
+ Revision: 606427
- rebuild

* Wed Mar 17 2010 Oden Eriksson <oeriksson@mandriva.com> 0:2.4.0-0.0.2mdv2010.1
+ Revision: 523214
- rebuilt for 2010.1

* Sun Oct 04 2009 Oden Eriksson <oeriksson@mandriva.com> 0:2.4.0-0.0.1mdv2010.0
+ Revision: 453398
- rediffed one fuzzy patch

* Mon Oct 20 2008 Alexander Kurtakov <akurtakov@mandriva.org> 0:2.4.0-0.0.1mdv2009.1
+ Revision: 295816
- new version 2.4.0

* Thu Jul 31 2008 Alexander Kurtakov <akurtakov@mandriva.org> 0:2.3.2-0.0.1mdv2009.0
+ Revision: 257242
- fix group
- BR regexp
- BR jline
- BR jakarta-commons-digester
- BR jtidy
- BR junit
- new version 2.3.2

* Tue Mar 04 2008 Alexander Kurtakov <akurtakov@mandriva.org> 0:1.9.1-3.1.5mdv2008.1
+ Revision: 179024
- add zip BR

  + Oden Eriksson <oeriksson@mandriva.com>
    - rebuild

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

  + Thierry Vignaud <tv@mandriva.org>
    - kill re-definition of %%buildroot on Pixel's request

  + Anssi Hannula <anssi@mandriva.org>
    - buildrequire java-rpmbuild, i.e. build with icedtea on x86(_64)

* Sat Sep 15 2007 Anssi Hannula <anssi@mandriva.org> 0:1.9.1-3.1.3mdv2008.0
+ Revision: 87385
- remove unnecessary Requires(post) on java-gcj-compat
- rebuild to filter out autorequires of GCJ AOT objects

* Fri Aug 24 2007 David Walluck <walluck@mandriva.org> 0:1.9.1-3.1.2mdv2008.0
+ Revision: 70774
- fix build
- fix OSGi manifests

* Fri Jul 27 2007 David Walluck <walluck@mandriva.org> 0:1.9.1-3.1.1mdv2008.0
+ Revision: 56230
- sync with FC8


* Fri Mar 16 2007 Christiaan Welvaart <spturtle@mandriva.org> 1.9.1-3mdv2007.1
+ Revision: 144742
- rebuild for 2007.1

  + David Walluck <walluck@mandriva.org>
    - Import lucene

* Thu May 25 2006 David Walluck <walluck@mandriva.org> 0:1.9.1-2mdv2007.0
- rebuild for libgcj.so.7

* Tue Mar 28 2006 David Walluck <walluck@mandriva.org> 0:1.9.1-1mdk
- 1.9.1

* Thu Mar 02 2006 David Walluck <walluck@mandriva.org> 0:1.9-1mdk
- 1.9

* Wed Jan 18 2006 David Walluck <walluck@mandriva.org> 0:1.4.3-2.5mdk
- fix path to aot-compile-rpm
- BuildRequires: java-devel

* Tue Oct 25 2005 David Walluck <walluck@mandriva.org> 0:1.4.3-2.4mdk
- remove lib/junit-3.8.1.jar binary jar form source zip

* Tue Oct 25 2005 David Walluck <walluck@mandriva.org> 0:1.4.3-2.3mdk
- fix unversioned demos symlink

* Tue Oct 25 2005 David Walluck <walluck@mandriva.org> 0:1.4.3-2.2mdk
- add %%{name}{,-%%{version}}-src.zip (for eclipse)
- add unversioned demos symlink (fix, for eclipse)

* Sat May 28 2005 David Walluck <walluck@mandriva.org> 0:1.4.3-2.1mdk
- release

* Wed Apr 27 2005 Ville Skyttä <scop at jpackage.org> - 0:1.4.3-2jpp
- Add unversioned javadoc dir symlink.
- Crosslink with local JDK javadocs.
- Convert specfile to UTF-8.
- Fix URLs.

* Mon Jan 10 2005 Kaj J. Niemi <kajtzu@fi.basen.net> 0:1.4.3
- 1.4.3

* Tue Aug 24 2004 Fernando Nasser <fnasser at redhat.com> - 0:1.3-3jpp
- Rebuild with Ant 1.6.2

* Wed Jun 02 2004 Randy Watler <rwatler at finali.com> - 0:1.3-2jpp
- Upgrade to Ant 1.6.X

